-----------------------------------------------------------------------------------------------
-- Client Lua Script for DuelTool
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- DuelTool Module Definition
-----------------------------------------------------------------------------------------------
local DuelTool = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function DuelTool:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function DuelTool:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- DuelTool OnLoad
-----------------------------------------------------------------------------------------------
function DuelTool:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("DuelTool.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- DuelTool OnDocLoaded
-----------------------------------------------------------------------------------------------
function DuelTool:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "DuelToolForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("dt", "OnDuelToolOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- DuelTool Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/dt"
function DuelTool:OnDuelToolOn()
	self.wndMain:Invoke() -- show the window
end


-----------------------------------------------------------------------------------------------
-- DuelToolForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function DuelTool:OnOK()
	GameLib.InitiateDuel()
end

-- when the Cancel button is clicked
function DuelTool:OnCancel()
	self.wndMain:Close() -- hide the window
end


function DuelTool:OnForfeit()
	GameLib.ForfeitDuel()
	GameLib.DeclineDuel()
	
end

-----------------------------------------------------------------------------------------------
-- DuelTool Instance
-----------------------------------------------------------------------------------------------
local DuelToolInst = DuelTool:new()
DuelToolInst:Init()
